# alpha.tcl - fred.

namespace import ::GL::*

tom .gl -width 200 -height 200

glEnable $GL::GL_BLEND
glBlendFunc $GL::GL_SRC_ALPHA $GL::GL_ONE_MINUS_SRC_ALPHA
glShadeModel $GL::GL_FLAT
glClearColor 0.0 0.0 0.0 0.0

set leftFirst 1

proc drawLeft {} {
    # draw yellow triangle on LHS of screen
    glBegin $GL::GL_TRIANGLES
    glColor4d 1.0 1.0 0.5 0.75
    glVertex3d 0.1 0.9 0.0
    glVertex3d 0.1 0.1 0.0 
    glVertex3d 0.7 0.5 0.0 
    glEnd
}

proc drawRight {} {
    # draw cyan triangle on RHS of screen
    glBegin $GL::GL_TRIANGLES
    glColor4d 0.0 1.0 1.0 0.75
    glVertex3d 0.9 0.9 0.0
    glVertex3d 0.3 0.5 0.0 
    glVertex3d 0.9 0.1 0.0 
    glEnd
}

proc redraw {} {
    global leftFirst
    glClear $GL::GL_COLOR_BUFFER_BIT
    if {$leftFirst == 1} {
	drawLeft
	drawRight
    } else {
	drawRight
	drawLeft
    }
    glFlush
}

bind .gl <Expose> {redraw}

bind .gl <Configure> {
    glViewport 0 0 %w %h
    glMatrixMode $GL::GL_PROJECTION
    glLoadIdentity
    if {%w <= (%h * 2)} {
	gluOrtho2D 0.0 1.0 0.0 [expr (1.0 * %h) / %w]
    } else {
	gluOrtho2D 0.0 [expr (1.0 * %w) / %h] 0.0 1.0 
    }
    glMatrixMode $GL::GL_MODELVIEW
    glLoadIdentity
}

bind .gl <ButtonPress-1> {
    if {$leftFirst != 0} {set leftFirst 0} else {set leftFirst 1}
    redraw
}

bind .gl <KeyPress> {
    if {[expr ([string compare %A t] == 0) || ([string compare %A T] == 0)] == 1} {
	if {$leftFirst != 0} {set leftFirst 0} else {set leftFirst 1}
	redraw
    }
}

pack .gl -expand 1 -fill both
focus .gl
