# bezcurve.tcl - fred.

namespace import ::GL::*

set ctrlpoints [list\
	{-4.0 -4.0 0.0}\
	{-2.0 4.0 0.0}\
	{2.0 -4.0 0.0}\
	{4.0 4.0 0.0}]

proc init {} {
    global ctrlpoints
    glClearColor 0.0 0.0 0.0 1.0
    glMap1f $GL::GL_MAP1_VERTEX_3 0.0 1.0 3 4 [eval concat $ctrlpoints]
    glEnable $GL::GL_MAP1_VERTEX_3
    glShadeModel $GL::GL_FLAT
}

proc display {} {
    global ctrlpoints
    glClear [expr $GL::GL_COLOR_BUFFER_BIT | $GL::GL_DEPTH_BUFFER_BIT]
    glColor3f 1.0 1.0 1.0
    glBegin $GL::GL_LINE_STRIP
    for {set i 0} {$i < 30} {incr i} {
	glEvalCoord1f [expr $i / 30.0]
    }
    glEnd
    glPointSize 5
    glColor3f 1.0 1.0 0.0
    glBegin $GL::GL_POINTS
    foreach p $ctrlpoints {glVertex3f [lindex $p 0] [lindex $p 1] [lindex $p 2]}
    glEnd
    glFlush
}

tom .gl -width 200 -height 200

init

bind .gl <Configure> {
    glViewport 0 0 %w %h
    glMatrixMode $GL::GL_PROJECTION
    glLoadIdentity
    if {%w <= %h} {
	glOrtho -5.0 5.0 [expr (-5.0 * %h) / %w] [expr (5.0 * %h) / %w] -5.0 5.0
    } else {
	glOrtho [expr (-5.0 * %w) / %h] [expr (5.0 * %w) / %h] -5.0 5.0 -5.0 5.0
    }
    glMatrixMode $GL::GL_MODELVIEW
    glLoadIdentity
}

bind .gl <Expose> {display}

pack .gl -expand 1 -fill both
