# bezmesh.tcl - fred.

namespace import ::GL::*

set ctrlpoints [binary format f* [list\
	-1.5 -1.5 4.0\
	-0.5 -1.5 2.0\
	0.5 -1.5 -1.0\
	1.5 -1.5 2.0\
	-1.5 -0.5 1.0\
	-0.5 -0.5 3.0\
	0.5 -0.5 0.0\
	1.5 -0.5 -1.0\
	-1.5 0.5 4.0\
	-0.5 0.5 0.0\
	0.5 0.5 3.0\
	1.5 0.5 4.0\
	-1.5 1.5 -2.0\
	-0.5 1.5 -2.0\
	0.5 1.5 0.0\
	1.5 1.5 -1.0]]

proc init {} {
    global ctrlpoints

    glClearColor 0.0 0.0 0.0 1.0
    glEnable $GL::GL_DEPTH_TEST
    glMap2f -bin -var $GL::GL_MAP2_VERTEX_3 0.0 1.0 3 4 0.0 1.0 12 4 ctrlpoints
    glEnable $GL::GL_MAP2_VERTEX_3
    glEnable $GL::GL_AUTO_NORMAL
    glMapGrid2f 8 0.0 1.0 8 0.0 1.0
    glDepthFunc $GL::GL_LESS
    glShadeModel $GL::GL_SMOOTH
    # lights
    glEnable $GL::GL_LIGHTING
    glEnable $GL::GL_LIGHT0
    glLightfv $GL::GL_LIGHT0 $GL::GL_AMBIENT {0.2 0.2 0.2 1.0}
    glLightfv $GL::GL_LIGHT0 $GL::GL_POSITION {0.0 0.0 2.0 1.0}
    glMaterialfv $GL::GL_FRONT_AND_BACK $GL::GL_DIFFUSE {0.6 0.6 0.6 1.0}
    glMaterialfv $GL::GL_FRONT_AND_BACK $GL::GL_SPECULAR {1.0 1.0 1.0 1.0}
    glMaterialfv $GL::GL_FRONT_AND_BACK $GL::GL_SHININESS {50.0}
}

proc display {} {
    global ctrlpoints
    glClear [expr $GL::GL_COLOR_BUFFER_BIT | $GL::GL_DEPTH_BUFFER_BIT]
    glColor3f 1.0 1.0 1.0
    glPushMatrix
    glRotatef 85.0 1.0 1.0 1.0
    glEvalMesh2 $GL::GL_FILL 0 8 0 8
    glPopMatrix
    glFlush
}

tom .gl -depth 1 -width 200 -height 200

init

bind .gl <Configure> {
    glViewport 0 0 %w %h
    glMatrixMode $GL::GL_PROJECTION
    glLoadIdentity
    if {%w <= %h} {
	glOrtho -5.0 5.0 [expr (-5.0 * %h) / %w] [expr (5.0 * %h) / %w] -5.0 5.0
    } else {
	glOrtho [expr (-5.0 * %w) / %h] [expr (5.0 * %w) / %h] -5.0 5.0 -5.0 5.0
    }
    glMatrixMode $GL::GL_MODELVIEW
    glLoadIdentity
}

bind .gl <Expose> {display}

pack .gl -expand 1 -fill both
