# bezsurf.tcl - fred.

namespace import ::GL::*

set ctrlpoints [binary format d* [list\
	-1.5 -1.5 4.0\
	-0.5 -1.5 2.0\
	0.5 -1.5 -1.0\
	1.5 -1.5 2.0\
	-1.5 -0.5 1.0\
	-0.5 -0.5 3.0\
	0.5 -0.5 0.0\
	1.5 -0.5 -1.0\
	-1.5 0.5 4.0\
	-0.5 0.5 0.0\
	0.5 0.5 3.0\
	1.5 0.5 4.0\
	-1.5 1.5 -2.0\
	-0.5 1.5 -2.0\
	0.5 1.5 0.0\
	1.5 1.5 -1.0]]

proc init {} {
    global ctrlpoints
    glClearColor 0.0 0.0 0.0 1.0
    glMap2d -b -var $GL::GL_MAP2_VERTEX_3 0.0 1.0 3 4 0.0 1.0 12 4 ctrlpoints
    glEnable $GL::GL_MAP2_VERTEX_3
    glEnable $GL::GL_DEPTH_TEST
    glDepthFunc $GL::GL_LESS
    glShadeModel $GL::GL_FLAT
}

proc display {} {
    glClear [expr $GL::GL_COLOR_BUFFER_BIT | $GL::GL_DEPTH_BUFFER_BIT]
    glColor3f 1.0 1.0 1.0
    glPushMatrix
    glRotatef 85.0 1.0 1.0 1.0
    for {set j 0} {$j <= 8} {incr j} {
	glBegin $GL::GL_LINE_STRIP
	for {set i 0} {$i <= 30} {incr i} {
	    glEvalCoord2d [expr $i / 30.0] [expr $j / 8.0]
	}
	glEnd
	glBegin $GL::GL_LINE_STRIP
	for {set i 0} {$i <= 30} {incr i} {
	    glEvalCoord2d [expr $j / 8.0] [expr $i / 30.0]
	}
	glEnd
    }
    glPopMatrix
    glFlush
}

tom .gl -depth 1 -width 200 -height 200

init

bind .gl <Configure> {
    glViewport 0 0 %w %h
    glMatrixMode $GL::GL_PROJECTION
    glLoadIdentity
    if {%w <= %h} {
	glOrtho -5.0 5.0 [expr (-5.0 * %h) / %w] [expr (5.0 * %h) / %w] -5.0 5.0
    } else {
	glOrtho [expr (-5.0 * %w) / %h] [expr (5.0 * %w) / %h] -5.0 5.0 -5.0 5.0
    }
    glMatrixMode $GL::GL_MODELVIEW
    glLoadIdentity
}

bind .gl <Expose> {display}

pack .gl -expand 1 -fill both
