# checker.tcl - fred.

namespace import ::GL::*

proc init {} {
    glClearColor 0.0 0.0 0.0 0.0
    glEnable $GL::GL_DEPTH_TEST
    glDepthFunc $GL::GL_LESS
    glShadeModel $GL::GL_SMOOTH

    # make texture
    set checkImageWidth 64
    set checkImageHeight 64
    set tex {}
    for {set i 0} {$i < $checkImageWidth} {incr i} {
	for {set j 0} {$j < $checkImageHeight} {incr j} {
	    set c [expr ((($i & 8) == 0) ^ (($j & 8) == 0)) * 255]
	    lappend tex $c $c $c
	}
    }
    set tex [binary format c* $tex]
    glPixelStorei $GL::GL_UNPACK_ALIGNMENT 1
    glTexImage2D -b -var $GL::GL_TEXTURE_2D 0 3\
	    $checkImageWidth $checkImageHeight\
	    0 $GL::GL_RGB $GL::GL_UNSIGNED_BYTE tex
    glTexParameteri $GL::GL_TEXTURE_2D $GL::GL_TEXTURE_WRAP_S $GL::GL_CLAMP
    glTexParameteri $GL::GL_TEXTURE_2D $GL::GL_TEXTURE_WRAP_T $GL::GL_CLAMP
    glTexParameteri $GL::GL_TEXTURE_2D $GL::GL_TEXTURE_MAG_FILTER $GL::GL_LINEAR
    glTexParameteri $GL::GL_TEXTURE_2D $GL::GL_TEXTURE_MIN_FILTER $GL::GL_LINEAR
    glTexEnvi $GL::GL_TEXTURE_ENV $GL::GL_TEXTURE_ENV_MODE $GL::GL_DECAL
    glEnable $GL::GL_TEXTURE_2D
}

proc display {} {
    glClear [expr $GL::GL_COLOR_BUFFER_BIT | $GL::GL_DEPTH_BUFFER_BIT]
    
    glBegin $GL::GL_QUADS

    glTexCoord2f 0.0 0.0; glVertex3f -2.0 -1.0 0.0
    glTexCoord2f 0.0 1.0; glVertex3f -2.0 1.0 0.0
    glTexCoord2f 1.0 1.0; glVertex3f 0.0 1.0 0.0
    glTexCoord2f 1.0 0.0; glVertex3f 0.0 -1.0 0.0
    
    glTexCoord2f 0.0 0.0; glVertex3f 1.0 -1.0 0.0
    glTexCoord2f 0.0 1.0; glVertex3f 1.0 1.0 0.0
    glTexCoord2f 1.0 1.0; glVertex3f 2.41421 1.0 -1.41421
    glTexCoord2f 1.0 0.0; glVertex3f 2.41421 -1.0 -1.41421
    
    glEnd

    glFlush
}

tom .gl -width 200 -height 200 -depth 1

init

bind .gl <Expose> {display}

bind .gl <Configure> {
    glViewport 0 0 %w %h
    glMatrixMode $GL::GL_PROJECTION
    glLoadIdentity
    gluPerspective 60.0 [expr double(%w) / double (%h)] 1.0 30.0
    glMatrixMode $GL::GL_MODELVIEW
    glLoadIdentity
    glTranslatef 0.0 0.0 -3.6
}

pack .gl -fill both -expand true
