catch {namespace import ::GL::*}
catch {destroy .gl}

proc draw {} {
    #puts "draw!"
    glClear $GL::GL_COLOR_BUFFER_BIT
    .gl swap
}

proc mdraw {r g b} {
	glClearColor $r $g $b 0
	.gl expose
}

proc sdraw {{v -1}} {
	if {$v >= 0} {
		glClearColor $v $v $v 0
	}
	.gl expose
}

tom .gl -width 200 -height 200 -doublebuffer 1

bind .gl <Configure> {
    #puts "<Configure %w %h>"
    glViewport 0 0 %w %h
    draw
}

bind .gl <Expose> {
    #puts "<Expose %x %y %h %w %c>"
    draw
}

grid .gl -row 0 -column 0 -sticky nsew
grid rowconfigure . 0 -weight 1
grid columnconfigure . 0 -weight 1

menu .m
set m [menu .m.colors]
.m add cascade -label "Colors" -menu $m
$m add command -label "Cyan" -command "mdraw 0 1 1"
$m add command -label "Yellow" -command "mdraw 1 1 0"
$m add command -label "Purple" -command "mdraw 1 0 1"
. configure -menu .m

# linux & windows
button .b1 -activebackground "#f00" -text "expose" -command {
    glClearColor 1 0 0 0
    .gl expose
}
grid .b1 -row 1 -column 0 -sticky ew

# linux only
button .b2 -activebackground "#0f0" -text "<Expose>" -command {
    glClearColor 0 1 0 0
    event generate .gl <Expose>
}
grid .b2 -row 2 -column 0 -sticky ew

# linux only
button .b3 -activebackground "#00f" -text "draw" -command {
    glClearColor 0 0 1 0
    draw
}
grid .b3 -row 3 -column 0 -sticky ew

# linux only (strange)
scale .s1 -from 0 -to 1 -command sdraw -res 0.01 -orient h
grid .s1 -row 4 -column 0 -sticky ew

set g 0
set run 0
proc tdraw {} {
	global g run
	set g [expr $g + 0.01]
	if {$g > 1.0} {set g 0.0}
	glClearColor $g 0 $g 0
	.gl expose
	if {$run == 1} {after idle tdraw}
}

checkbutton .cb1 -text auto -command tdraw -variable run
grid .cb1 -row 5 -column 0 -sticky w
