# frustum.tcl - fred.

namespace import ::GL::*

proc init {} {
    # setup lighting, etc

    # Set the clear color to black
    glClearColor 0.0 0.0 0.0 0.0
    
    # Set the shading model
    glShadeModel $GL::GL_FLAT
    
    # Set the polygon mode to fill
    glPolygonMode $GL::GL_FRONT_AND_BACK $GL::GL_FILL
    
    # Enable depth testing for hidden line removal
    glEnable $GL::GL_DEPTH_TEST
}

proc sphere radius {
    set q [gluNewQuadric]
    gluSphere $q $radius 16 16
    gluDeleteQuadric $q
}

proc display {} {
    glClear [expr $GL::GL_COLOR_BUFFER_BIT | $GL::GL_DEPTH_BUFFER_BIT]


    glPushMatrix
    
    glTranslatef 0.0 0.0 -15.0
    glColor3f 0.0 1.0 0.0
    sphere 1.0
    
    glTranslatef -2.5 0.0 30.0
    glColor3f 1.0 0.0 0.0
    sphere 1.0
    
    glTranslatef -15.0 0.0 -15.0
    glColor3f 1.0 1.0 0.0
    sphere 1.0
    
    glTranslatef 30.0 0.0 0.0
    glColor3f 0.0 1.0 1.0
    sphere 1.0
    
    glPopMatrix 
    
    glRotatef 1 0.0 1.0 0.0  
    
    .gl swapbuffers
}

tom .gl -doublebuffer 1 -depth 1 -width 200 -height 200

init

bind .gl <Configure> {
    glViewport 0 0 %w %h
    glMatrixMode $GL::GL_PROJECTION
    glLoadIdentity
    glFrustum -10.0 10.0 -10.0 10.0 10.0 20.0
    glMatrixMode $GL::GL_MODELVIEW
    glLoadIdentity
}

bind .gl <Expose> {display}

pack .gl -fill both -expand true

set RUN 0
proc run {} {
    global RUN
    if {$RUN != 0} {
	.gl expose
	after idle run
    }
}

bind .gl <KeyPress> {
    switch -exact -- %K {
	s {
	    if {$RUN == 0} {
		set RUN 1
		run
	    } else {set RUN 0}
	}
	Escape {exit}
    }
}

focus .gl