# mipmap.tcl - fred.

namespace import ::GL::*

proc init {} {
    # make textures
    set mipmapImage32 {}
    for {set i 0} {$i < 32} {incr i} {
	for {set j 0} {$j < 32} {incr j} {
	    lappend mipmapImage32 255 255 0
	}
    }
    set mipmapImage32 [binary format c* $mipmapImage32]
    set mipmapImage16 {}
    for {set i 0} {$i < 16} {incr i} {
	for {set j 0} {$j < 16} {incr j} {
	    lappend mipmapImage16 255 0 255
	}
    }
    set mipmapImage16 [binary format c* $mipmapImage16]
    set mipmapImage8 {}
    for {set i 0} {$i < 8} {incr i} {
	for {set j 0} {$j < 8} {incr j} {
	    lappend mipmapImage8 255 0 0
	}
    }
    set mipmapImage8 [binary format c* $mipmapImage8]
    set mipmapImage4 {}
    for {set i 0} {$i < 4} {incr i} {
	for {set j 0} {$j < 4} {incr j} {
	    lappend mipmapImage4 0 255 0
	}
    }
    set mipmapImage4 [binary format c* $mipmapImage4]
    set mipmapImage2 {}
    for {set i 0} {$i < 2} {incr i} {
	for {set j 0} {$j < 2} {incr j} {
	    lappend mipmapImage2 0 0 255
	}
    }
    set mipmapImage2 [binary format c* $mipmapImage2]
    set mipmapImage1 {255 255 255}
    set mipmapImage1 [binary format c* $mipmapImage1]

    glEnable $GL::GL_DEPTH
    glDepthFunc $GL::GL_LEQUAL
    glShadeModel $GL::GL_FLAT
    glTranslatef 0.0 0.0 -3.6
    glPixelStorei $GL::GL_UNPACK_ALIGNMENT 1
    glTexImage2D -b -var $GL::GL_TEXTURE_2D 0 3 32 32 0\
	    $GL::GL_RGB $GL::GL_UNSIGNED_BYTE mipmapImage32
    glTexImage2D -b -var $GL::GL_TEXTURE_2D 1 3 16 16 0\
	    $GL::GL_RGB $GL::GL_UNSIGNED_BYTE mipmapImage16
    glTexImage2D -b -var $GL::GL_TEXTURE_2D 2 3 8 8 0\
	    $GL::GL_RGB $GL::GL_UNSIGNED_BYTE mipmapImage8
    glTexImage2D -b -var $GL::GL_TEXTURE_2D 3 3 4 4 0\
	    $GL::GL_RGB $GL::GL_UNSIGNED_BYTE mipmapImage4
    glTexImage2D -b -var $GL::GL_TEXTURE_2D 4 3 2 2 0\
	    $GL::GL_RGB $GL::GL_UNSIGNED_BYTE mipmapImage2
    glTexImage2D -b -var $GL::GL_TEXTURE_2D 5 3 1 1 0\
	    $GL::GL_RGB $GL::GL_UNSIGNED_BYTE mipmapImage1
    glTexParameteri $GL::GL_TEXTURE_2D $GL::GL_TEXTURE_WRAP_S $GL::GL_REPEAT
    glTexParameteri $GL::GL_TEXTURE_2D $GL::GL_TEXTURE_WRAP_T $GL::GL_REPEAT
    glTexParameteri $GL::GL_TEXTURE_2D $GL::GL_TEXTURE_MAG_FILTER $GL::GL_NEAREST
    glTexParameteri $GL::GL_TEXTURE_2D $GL::GL_TEXTURE_MIN_FILTER\
	    $GL::GL_NEAREST_MIPMAP_NEAREST
    glTexEnvi $GL::GL_TEXTURE_ENV $GL::GL_TEXTURE_ENV_MODE $GL::GL_DECAL
    glEnable $GL::GL_TEXTURE_2D
}

proc display {} {
    glClear [expr $GL::GL_COLOR_BUFFER_BIT | $GL::GL_DEPTH_BUFFER_BIT]
    glBegin $GL::GL_QUADS
    glTexCoord2f 0.0 0.0; glVertex3f -2.0 -1.0 0.0
    glTexCoord2f 0.0 8.0; glVertex3f -2.0 1.0 0.0
    glTexCoord2f 8.0 8.0; glVertex3f 2000.0 1.0 -6000.0
    glTexCoord2f 8.0 0.0; glVertex3f 2000.0 -1.0 -6000.0
    glEnd
    glFlush
}

tom .gl -width 200 -height 150

init

bind .gl <Expose> {display}

bind .gl <Configure> {
    glViewport 0 0 %w %h
    glMatrixMode $GL::GL_PROJECTION
    glLoadIdentity
    gluPerspective 60.0 [expr double(%w) / double(%h)] 1.0 30000.0
    glMatrixMode $GL::GL_MODELVIEW
    glLoadIdentity
    display
}

pack .gl -fill both -expand true
