# picksquare - fred.

namespace import ::GL::*

proc init {} {
    global board
    for {set i 0} {$i < 3} {incr i} {
	for {set j 0} {$j < 3} {incr j} {
	    set board($i.$j) 0
	}
    }
    glClearColor 0.0 0.0 0.0 0.0

    proc drawSquares {mode} {
	global board
	for {set i 0} {$i < 3} {incr i} {
	    if {$mode == $GL::GL_SELECT} {glLoadName $i}
	    for {set j 0} {$j < 3} {incr j} {
		if {$mode == $GL::GL_SELECT} {glPushName $j}
		glColor3f [expr double($i) / 3.0]\
			[expr double($j) / 3.0]\
			[expr double($board($i.$j)) / 3.0]
		glRecti $i $j [expr $i + 1] [expr $j + 1]
		if {$mode == $GL::GL_SELECT} glPopName
	    }
	}
    }
}

proc processHits {hits buffer} {
    global board
    puts "hits = $hits"
    binary scan $buffer i* buffer
    set ptr 0
    for {set i 0} {$i < $hits} {incr i} {
	set names [lindex $buffer $ptr]; incr ptr
	puts " number of names for hit = $names"
	puts -nonewline "  z1 is [lindex $buffer $ptr]"; incr ptr
	puts -nonewline "  z2 is [lindex $buffer $ptr]"; incr ptr
	puts -nonewline "   the names are"
	# for each name
	for {set j 0} {$j < $names} {incr j} {
	    puts -nonewline " [lindex $buffer $ptr]"
	    # set row and column
	    if {$j == 0} {
		set ii [lindex $buffer $ptr]
	    } else {
		set jj [lindex $buffer $ptr]
	    }
	    incr ptr
	}
	puts ""
	set board($ii.$jj) [expr ($board($ii.$jj) + 1) % 3]
    }
}
    
proc pickSquares {x y} {
    glGetIntegerv $GL::GL_VIEWPORT vp
    glSelectBuffer 512 selectBuf
    glRenderMode $GL::GL_SELECT
    
    glInitNames
    glPushName -1
    
    glMatrixMode $GL::GL_PROJECTION
    glPushMatrix
    glLoadIdentity
    # create 5x5 pixels picking region near cursor location
    gluPickMatrix $x [expr [lindex $vp 3] - $y] 5 5 $vp
    gluOrtho2D 0.0 3.0 0.0 3.0
    drawSquares $GL::GL_SELECT
    glPopMatrix
    glFlush
    set hits [glRenderMode $GL::GL_RENDER]
    processHits $hits $selectBuf
    display
}

proc display {} {
    glClear $GL::GL_COLOR_BUFFER_BIT
    drawSquares $GL::GL_RENDER
    glFlush
}

tom .gl -width 150 -height 150

init

bind .gl <Configure> {
    glViewport 0 0 %w %h
    glMatrixMode $GL::GL_PROJECTION
    glLoadIdentity
    gluOrtho2D 0.0 3.0 0.0 3.0
    glMatrixMode $GL::GL_MODELVIEW
    glLoadIdentity
}

bind .gl <Expose> {display}

bind .gl <ButtonPress-1> {pickSquares %x %y}

pack .gl -fill both -expand 1
