# planet.tcl - fred.

namespace import ::GL::*

proc init {} {
    global year day
    glClearColor 0.0 0.0 0.0 0.0
    glShadeModel $GL::GL_FLAT
    glPolygonMode $GL::GL_FRONT_AND_BACK $GL::GL_LINE

    set year 0
    set day 0
}
 
proc sphere {radius slices stacks} {
    set q [gluNewQuadric]
    gluSphere $q $radius $slices $stacks
    gluDeleteQuadric $q
}

proc display {} {
    global gl day year

    glClear $GL::GL_COLOR_BUFFER_BIT
    glColor3f 1.0 1.0 1.0
    
    glPushMatrix
    # draw sun
    #glutWireSphere 1.0 20 16
    sphere 1.0 20 16
    glRotatef $year 0.0 1.0 0.0
    glTranslatef 2.0 0.0 0.0
    glRotatef $day 0.0 1.0 0.0
    # draw smaller planet
    #glutWireSphere 0.2 10 8
    sphere 0.2 10 8
    glPopMatrix
    $gl swapbuffers
}

frame .f
pack .f -fill both -expand 1
set gl [tom .f.gl -doublebuffer 1 -width 250 -height 250]

init

bind $gl <Configure> {
    glViewport 0 0 %w %h 
    glMatrixMode $GL::GL_PROJECTION
    glLoadIdentity
    gluPerspective 60.0 [expr double(%w) / double(%h)] 1.0 20.0
    glMatrixMode $GL::GL_MODELVIEW
    glLoadIdentity
    gluLookAt 0.0 0.0 5.0 0.0 0.0 0.0 0.0 1.0 0.0
}

bind $gl <Expose> {display}

bind $gl <KeyPress> {
    switch -exact -- %K {
	d {
	    set day [expr ($day + 10) %% 360]
	    $gl expose
	}
	D {
	    set day [expr ($day - 10) %% 360]
	    $gl expose
	}
	y {
	    set year [expr ($year + 5) %% 360]
	    $gl expose
	}
	Y {
	    set year [expr ($year - 5) %% 360]
	    $gl expose
	}
	Escape {destroy .}
    }
}   

pack $gl -fill both -expand true
focus $gl
