# more_simple.tcl - fred.

namespace import ::GL::*

tom .g1 -width 150 -height 50
tom .g2 -width 150 -height 50 -share .g1
tom .g3 -width 150 -height 50

proc triangle {n x} {
    glNewList $n $GL::GL_COMPILE
    glBegin $GL::GL_TRIANGLES
    glColor3f 1.0 0.0 0.0
    glVertex2f $x 0.5
    glColor3f 0.0 1.0 0.0
    glVertex2f [expr $x - 0.3] -0.5
    glColor3f 0.0 0.0 1.0
    glVertex2f [expr $x + 0.3] -0.5
    glEnd
    glEndList
}

# list 1 is defined in .gl1's context.
# list 2 is defined in .gl2's context.
# list 3 is defined in .gl3's context.

.g1 makecurrent
glShadeModel $GL::GL_SMOOTH
triangle 1 -0.7

.g2 makecurrent
glShadeModel $GL::GL_FLAT
triangle 2 0

.g3 makecurrent
glShadeModel $GL::GL_SMOOTH
triangle 3 0.7

proc reshape {w width height} {
    $w makecurrent
    glViewport 0 0 $width $height
}

proc redraw {w} {
    $w makecurrent
    glClearColor 0.0 .0 0.0 0.0
    glClear $GL::GL_COLOR_BUFFER_BIT
    glCallList 1
    glCallList 2
    glCallList 3
    glFlush
}

bind .g1 <Configure> {reshape %W %w %h}
bind .g2 <Configure> {reshape %W %w %h}
bind .g3 <Configure> {reshape %W %w %h}

bind .g1 <Expose> {redraw %W}
bind .g2 <Expose> {redraw %W}
bind .g3 <Expose> {redraw %W}

pack .g1 .g2 .g3 -fill both -expand 1
