# texturesurf.tcl - fred.

namespace import ::GL::*

set ctrlpts [binary format f* [list\
	-1.5 -1.5 4.0\
	-0.5 -1.5 2.0\
	0.5 -1.5 -1.0\
	1.5 -1.5 2.0\
	-1.5 -0.5 1.0\
	-0.5 -0.5 3.0\
	0.5 -0.5 0.0\
	1.5 -0.5 -1.0\
	-1.5 0.5 4.0\
	-0.5 0.5 0.0\
	0.5 0.5 3.0\
	1.5 0.5 4.0\
	-1.5 1.5 -2.0\
	-0.5 1.5 -2.0\
	0.5 1.5 0.0\
	1.5 1.5 -1.0]]

set texpts [binary format f* [list 0.0 0.0 0.0 1.0 1.0 0.0 1.0 1.0]]

proc display {} {
    glClear [expr $GL::GL_COLOR_BUFFER_BIT | $GL::GL_DEPTH_BUFFER_BIT]
    glColor3f 1.0 1.0 1.0
    glEvalMesh2 $GL::GL_FILL 0 20 0 20
    glFlush
}

proc init {} {
    global ctrlpts texpts
    glMap2f -b -var $GL::GL_MAP2_VERTEX_3 0.0 1.0 3 4 0.0 1.0 12 4 ctrlpts
    glMap2f -b -var $GL::GL_MAP2_TEXTURE_COORD_2 0.0 1.0 2 2 0.0 1.0 4 2 texpts
    glEnable $GL::GL_MAP2_TEXTURE_COORD_2
    glEnable $GL::GL_MAP2_VERTEX_3
    glMapGrid2f 20 0.0 1.0 20 0.0 1.0

    set imageWidth 64
    set imageHeight 64
    set pi [expr atan(1) * 4]
    for {set i 0} {$i < $imageWidth} {incr i} {
	set ti [expr 2.0 * $pi * $i / double($imageWidth)]
	for {set j 0} {$j < $imageHeight} {incr j} {
	    set tj [expr 2.0 * $pi * $j / double($imageHeight)]
	    set tmp([expr 3 * ($imageHeight * $i + $j)])\
		    [expr int(127 * (1.0 + sin($ti)))]
	    set tmp([expr 3 * ($imageHeight * $i + $j) + 1])\
		    [expr int(127 * (1.0 + cos(2 * $tj)))]
	    set tmp([expr 3 * ($imageHeight * $i + $j) + 2])\
		    [expr int(127 * (1.0 + cos($ti + $tj)))]
	}
    }
    foreach n [lsort -integer [array names tmp]] {lappend image $tmp($n)}
    set image [binary format c* $image]
    glTexEnvf $GL::GL_TEXTURE_ENV $GL::GL_TEXTURE_ENV_MODE $GL::GL_DECAL
    glTexParameterf $GL::GL_TEXTURE_2D $GL::GL_TEXTURE_WRAP_S $GL::GL_REPEAT
    glTexParameterf $GL::GL_TEXTURE_2D $GL::GL_TEXTURE_WRAP_T $GL::GL_REPEAT
    glTexParameterf $GL::GL_TEXTURE_2D $GL::GL_TEXTURE_MAG_FILTER $GL::GL_NEAREST
    glTexParameterf $GL::GL_TEXTURE_2D $GL::GL_TEXTURE_MIN_FILTER $GL::GL_NEAREST
    glTexImage2D -b -var $GL::GL_TEXTURE_2D 0 3 $imageWidth $imageHeight 0\
	    $GL::GL_RGB $GL::GL_UNSIGNED_BYTE image
    glEnable $GL::GL_TEXTURE_2D
    glEnable $GL::GL_DEPTH_TEST
    glEnable $GL::GL_NORMALIZE
    glShadeModel $GL::GL_FLAT
}

tom .gl -depth 1 -width 200 -height 200

init

bind .gl <Configure> {
    glViewport 0 0 %w %h
    glMatrixMode $GL::GL_PROJECTION
    glLoadIdentity
    if {%w <= %h} {
	glOrtho -4.0 4.0 [expr (-4.0 * %h) / %w] [expr (4.0 * %h) / %w] -4.0 4.0
    } else {
	glOrtho [expr (-4.0 * %w) / %h] [expr (4.0 * %w) / %h] -4.0 4.0 -4.0 4.0
    }
    glMatrixMode $GL::GL_MODELVIEW
    glLoadIdentity
    glRotatef 85.0 1.0 1.0 1.0
}

bind .gl <Expose> display

pack .gl -expand 1 -fill both
